package org.eclipse.jwt.transformations.base;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import org.eclipse.core.runtime.Status;
import org.eclipse.jface.dialogs.ErrorDialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

public class TransformationRegistry {
	private Map<String, TransformationService> transformations;
	private static TransformationRegistry instance = null;
	
	
	public static TransformationRegistry getInstance() {
		if (instance == null)
			instance = new TransformationRegistry();
		return instance;
	}
	
	private TransformationRegistry() {
		transformations = new HashMap<String, TransformationService>();
	}
	
	public void addTransformation(String name, TransformationService transformation) {
		if (transformations.put(name, transformation) != null) {
			final Display display = Display.getCurrent();
			final Shell shell = new Shell(display);
			ErrorDialog.openError(shell, "Transformation already deployed", "A transformation named \"" + name + "\" was already deployed at this extension! It has been replaced.", Status.OK_STATUS);
		}

	}
	
	public TransformationService getTransformation(String name) {
		return transformations.get(name);
	}
	
	public Set<String> getTransformationsName() {
		return transformations.keySet();
	}
}
